Imports System.IO

Public Class Form1
    Dim senden As String
    Dim log As String

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked = True Then
            TextBox1.Visible = True
            TextBox2.Visible = True
            TextBox3.Visible = True
            TextBox4.Visible = True
            TextBox5.Visible = True
            TextBox6.Visible = True
            TextBox7.Visible = True
            Label1.Visible = True
            Label2.Visible = True
            Label3.Visible = True
            Label4.Visible = True
            Label5.Visible = True
            Label6.Visible = True
            Label7.Visible = True
            Label8.Visible = True
            Label9.Visible = True
            Label10.Visible = True
            Label11.Visible = True
            Label12.Visible = True
            Label13.Visible = True
            Label14.Visible = True
            Label15.Visible = True
            Label16.Visible = True
            Label17.Visible = True
            Label18.Visible = True
            Label19.Visible = True
            Label20.Visible = True
            Label21.Visible = True
            txtDataToSend.Visible = True
            btnSend.Visible = True

        Else
            TextBox2.Visible = False
            TextBox4.Visible = False
            TextBox6.Visible = False
            TextBox7.Visible = False
            Label3.Visible = False
            Label4.Visible = False
            Label10.Visible = False
            Label11.Visible = False
            Label12.Visible = False
            Label16.Visible = False
            Label17.Visible = False
            Label18.Visible = False
            Label19.Visible = False
            Label20.Visible = False
            Label21.Visible = False
            txtDataToSend.Visible = False
            btnSend.Visible = False

        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        End
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        senden = "PSRF109,11," & TextBox7.Text & "," + TextBox1.Text & "," & TextBox2.Text & "," & TextBox3.Text & "," + TextBox4.Text & "," & TextBox5.Text & "," & TextBox6.Text
        CheckSum(senden)
        Label5.Text = "Der Befehl " & senden & " wurde an das Modul gesendet"

        SerialPort.Write(senden & vbCrLf)

    End Sub
    Public Sub CheckSum(ByVal field As String)
        Dim i As Integer
        Dim CS As String
        If field = "" Then CS = "*"
        CS = 0
        For i = 1 To Len(field)
            CS = CS Xor Asc(Mid$(field, i, 1))
        Next
        CS = Hex(CS)
        If Len(CS) = 1 Then
            senden = "$" & senden & "0" & CS
        Else
            senden = "$" & senden & "*" & CS
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For i As Integer = 0 To _
           My.Computer.Ports.SerialPortNames.Count - 1
            cbbCOMPorts.Items.Add(My.Computer.Ports.SerialPortNames(i))
        Next
        btnDisconnect.Enabled = False
    End Sub
    Private Sub DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort.DataReceived
        txtDataReceived.Invoke(New myDelegate(AddressOf updateTextBox), New Object() {})
    End Sub

    Private Sub btnSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        Try
            SerialPort.Write(txtDataToSend.Text & vbCrLf)
            With txtDataReceived
                .SelectionColor = Color.Black
                .AppendText(txtDataToSend.Text & vbCrLf)
                .ScrollToCaret()
            End With
            txtDataToSend.Text = String.Empty
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Public Delegate Sub myDelegate()
    Public Sub updateTextBox()
        Dim temp As String
        temp = SerialPort.ReadExisting
        With txtDataReceived
            .AppendText(temp)
            .ScrollToCaret()
        End With
        log = log & temp
    End Sub

    Private Sub btnConnect_Click( _
       ByVal sender As System.Object, _
       ByVal e As System.EventArgs) _
       Handles btnConnect.Click
        If ComboBox1.Text = "Baudrate" Then
            MsgBox("Bitte Baudrate whlen")
            Exit Sub
        End If
        If cbbCOMPorts.Text = "whlen" Then
            MsgBox("Bitte COM Port whlen whlen")
            Exit Sub
        End If
        If SerialPort.IsOpen Then
            SerialPort.Close()
        End If
        Try
            With SerialPort
                .PortName = cbbCOMPorts.Text
                .BaudRate = ComboBox1.SelectedItem
                .Parity = IO.Ports.Parity.None
                .DataBits = 8
                .StopBits = IO.Ports.StopBits.One
                ' .Encoding = System.Text.Encoding.Unicode
            End With
            SerialPort.Open()

            lblMessage.Text = cbbCOMPorts.Text & " connected."
            btnConnect.Enabled = False
            btnDisconnect.Enabled = True
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub btnDisconnect_Click( _
       ByVal sender As System.Object, _
       ByVal e As System.EventArgs) _
       Handles btnDisconnect.Click
        Try
            SerialPort.Close()
            lblMessage.Text = SerialPort.PortName & " disconnected."
            btnConnect.Enabled = True
            btnDisconnect.Enabled = False
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If MsgBox("Wollen Sie das Zeitintervall der gespeicherten GPS Daten bestimmen?", MsgBoxStyle.YesNo, "Zeitintervall") = MsgBoxResult.Yes Then
            Dim startdatum = InputBox("Geben Sie das Startdatum ein; Format DDMMYY", "Startdatum")
            Dim startzeit = InputBox("Geben Sie die Startzeit(UTC) ein; Format HHMMSS", "Startzeit")
            Dim enddatum = InputBox("Geben Sie das Enddatum ein; Format DDMMYY", "Enddatum")
            Dim endzeit = InputBox("Geben Sie die Endzeit(UTC) ein; Format HHMMSS", "Endzeit")
            senden = "PSRF109,0," & startdatum & "," & startzeit & "," & enddatum & "," & endzeit
            CheckSum(senden)
            Label5.Text = "Der Befehl " & senden & " wurde an das Modul gesendet"
            SerialPort.Write(senden & vbCrLf)
            txtDataReceived.Text = ""
            log = ""
        Else
            SerialPort.Write("$PSRF109,0,0,0*33" & vbCrLf)
            txtDataReceived.Text = ""
            log = ""
        End If

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        txtDataReceived.Text = log
        Dim objStreamWriter As StreamWriter
        If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel Then
            Exit Sub
        End If
        objStreamWriter = New StreamWriter(SaveFileDialog1.FileName)
        objStreamWriter.WriteLine("Log File beginnt hier")
        objStreamWriter.WriteLine(log)
        objStreamWriter.Close()

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        If MsgBox("Sollen wirklich alle gespeicherten GPS Daten gelscht werden?", MsgBoxStyle.OkCancel, "GPS Daten lschen") = MsgBoxResult.Ok Then
            SerialPort.Write("$PSRF109,10*02")
            Label5.Text = "Der Befehl $PSRF109,10*02 wurde an das Modul gesendet"
        End If
    End Sub

    Private Sub TextBox1_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox1.MouseClick
        Label5.Text = "Der GPS Tracker zeichnet alle X Sekunden die NMEA Daten auf sofern die unten stehenden Bedingungen erfllt sind"
    End Sub

    Private Sub TextBox2_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox2.MouseClick
        Label5.Text = "Der GPS Tracker zeichnet alle X Sekunden die NMEA Daten auf auch wenn die unten stehenden Bedingungen nicht erfllt sind"
    End Sub

    Private Sub TextBox3_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox3.MouseClick
        Label5.Text = "Der GPS Tracker zeichnet nur dann die NMEA Daten auf wenn mindestens X Meter zurckgelegt wurden (0 = deaktiviert)"
    End Sub

    Private Sub TextBox4_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox4.MouseClick
        Label5.Text = "Der GPS Tracker zeichnet nur dann die NMEA Daten auf wenn hchstens X Meter zurckgelegt wurden (0 = deaktiviert)"
    End Sub

    Private Sub TextBox5_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox5.MouseClick
        Label5.Text = "Der GPS Tracker zeichnet nur dann die NMEA Daten auf wenn mindestens X km/h gefahren wurden (0 = deaktiviert)"
    End Sub

    Private Sub TextBox6_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox6.MouseClick
        Label5.Text = "Der GPS Tracker zeichnet nur dann die NMEA Daten auf wenn hchstens X km/h gefahren wurden (0 = deaktiviert)"
    End Sub

    Private Sub TextBox7_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox7.MouseClick
        Label5.Text = "Der GPS Tracker zeichnet nur dann die NMEA Daten auf wenn mindestens X Satelliten gefunden wurden"
    End Sub


End Class
